Subject: Re: [PATCH treewide v2 0/9] phy: Add devm_of_phy_optional_get() helper

From: Vinod Koul <[email-masked]>
Date: Fri, 3 Feb 2023 15:28:57 +0530

On 24-01-23, 19:37, Geert Uytterhoeven wrote:
> 	Hi Vinod et al,
> 
> While there exist several optional_get() PHY helper functions, there is
> no optional variant of devm_of_phy_get(), leading to several drivers
> implementing this theirselves, sometimes in buggy ways.
> 
> Hence this series, after two cleanup patches, introduces a
> devm_of_phy_optional_get() helper(), and converts existing users of
> devm_of_phy_get() where appropriate.

Applied and pushed to tag phy-devm_of_phy_optional_get

The following changes since commit 1b929c02afd37871d5afb9d498426f83432e71c2:

  Linux 6.2-rc1 (2022-12-25 13:41:39 -0800)

are available in the Git repository at:

  git://git.kernel.org/pub/scm/linux/kernel/git/phy/linux-phy.git tags/phy-devm_of_phy_optional_get

for you to fetch changes up to 41a435e30eb007ca2c8f71db734af6ec3509af4d:

  usb: host: ohci-exynos: Convert to devm_of_phy_optional_get() (2023-02-03 11:19:35 +0530)

----------------------------------------------------------------
Phy tag for new devm_of_phy_optional_get() API

----------------------------------------------------------------
Geert Uytterhoeven (8):
      phy: Remove unused phy_optional_get()
      doc: phy: Document devm_of_phy_get()
      phy: Add devm_of_phy_optional_get() helper
      net: fman: memac: Convert to devm_of_phy_optional_get()
      net: lan966x: Convert to devm_of_phy_optional_get()
      PCI: tegra: Convert to devm_of_phy_optional_get()
      usb: host: ehci-exynos: Convert to devm_of_phy_optional_get()
      usb: host: ohci-exynos: Convert to devm_of_phy_optional_get()

 Documentation/driver-api/phy/phy.rst                  | 24 ++++++++++++++----------
 drivers/net/ethernet/freescale/fman/fman_memac.c      |  9 ++++-----
 drivers/net/ethernet/microchip/lan966x/lan966x_main.c |  5 ++---
 drivers/pci/controller/pci-tegra.c                    |  5 +----
 drivers/phy/phy-core.c                                | 51 ++++++++++++++++++++++++++++++---------------------
 drivers/usb/host/ehci-exynos.c                        | 23 ++++++-----------------
 drivers/usb/host/ohci-exynos.c                        | 23 ++++++-----------------
 include/linux/phy/phy.h                               | 16 +++++++++-------
 8 files changed, 72 insertions(+), 84 deletions(-)

> Thanks!
> 
> > > --- a/drivers/net/ethernet/ti/am65-cpsw-nuss.c
> > > +++ b/drivers/net/ethernet/ti/am65-cpsw-nuss.c
> > > @@ -1460,11 +1460,9 @@ static int am65_cpsw_init_serdes_phy(struct device *dev, struct device_node *por
> > >       struct phy *phy;
> > >       int ret;
> > >
> > > -     phy = devm_of_phy_get(dev, port_np, name);
> > > -     if (PTR_ERR(phy) == -ENODEV)
> > > -             return 0;
> > > -     if (IS_ERR(phy))
> > > -             return PTR_ERR(phy);
> > > +     phy = devm_of_phy_optional_get(dev, port_np, name);
> > > +     if (IS_ERR_OR_NULL(phy))
> > > +             return PTR_ERR_OR_ZERO(phy);
> > >
> > >       /* Serdes PHY exists. Store it. */
> > >       port->slave.serdes_phy = phy;
> 
> Gr{oetje,eeting}s,
> 
>                         Geert
> 
> --
> Geert Uytterhoeven -- There's lots of Linux beyond ia32 -- [email-masked]
> 
> In personal conversations with technical people, I call myself a hacker. But
> when I'm talking to journalists I just say "programmer" or something like that.
>                                 -- Linus Torvalds

> 
> Changes compared to v1[1]:
>   - Incorporate "[PATCH v2 1/9] phy: Remove unused phy_optional_get()",
>     as it touches the same documentation,
>   - New patch "[PATCH v2 2/9] doc: phy: Document devm_of_phy_get()",
>   - Print an error message in case of failure, as requested by RobH,
>   - Update Documentation,
>   - Clarify removed checks for -ENODEV and -ENOSYS,
>   - Remove error printing in case of real failures from callers,
>   - Rebase am65-cpsw change on top of commit 854617f52ab42418 ("net:
>     ethernet: ti: am65-cpsw: Handle -EPROBE_DEFER for Serdes PHY") in
>     net-next (next-20230123 and later),
>   - Add Reviewed-by, Acked-by.
> 
> Most of this series been compile-tested only, but the new helper itself
> has been tested with a new user[2].
> 
> Thanks for your comments!
> 
> [1] "[PATCH treewide 0/7] phy: Add devm_of_phy_optional_get() helper"
>     https://lore.kernel.org/r/[email-masked]
> [2] "[PATCH 12/12] can: rcar_canfd: Add transceiver support"
>     https://lore.kernel.org/r/e825b[email-masked]
> 
> Geert Uytterhoeven (9):
>   phy: Remove unused phy_optional_get()
>   doc: phy: Document devm_of_phy_get()
>   phy: Add devm_of_phy_optional_get() helper
>   net: fman: memac: Convert to devm_of_phy_optional_get()
>   net: lan966x: Convert to devm_of_phy_optional_get()
>   net: ethernet: ti: am65-cpsw: Convert to devm_of_phy_optional_get()
>   PCI: tegra: Convert to devm_of_phy_optional_get()
>   usb: host: ehci-exynos: Convert to devm_of_phy_optional_get()
>   usb: host: ohci-exynos: Convert to devm_of_phy_optional_get()
> 
>  Documentation/driver-api/phy/phy.rst          | 24 +++++----
>  .../net/ethernet/freescale/fman/fman_memac.c  |  9 ++--
>  .../ethernet/microchip/lan966x/lan966x_main.c |  5 +-
>  drivers/net/ethernet/ti/am65-cpsw-nuss.c      |  8 ++-
>  drivers/pci/controller/pci-tegra.c            |  5 +-
>  drivers/phy/phy-core.c                        | 51 +++++++++++--------
>  drivers/usb/host/ehci-exynos.c                | 23 +++------
>  drivers/usb/host/ohci-exynos.c                | 23 +++------
>  include/linux/phy/phy.h                       | 16 +++---
>  9 files changed, 75 insertions(+), 89 deletions(-)
> 
> -- 
> 2.34.1
> 
> Gr{oetje,eeting}s,
> 
> 						Geert
> 
> --
> Geert Uytterhoeven -- There's lots of Linux beyond ia32 -- [email-masked]
> 
> In personal conversations with technical people, I call myself a hacker. But
> when I'm talking to journalists I just say "programmer" or something like that.
> 							    -- Linus Torvalds

-- 
~Vinod